function x = willettrnd(n,interval)
  
if nargin<2
  interval = [0,1];
end

breakpoint = (interval(2)+interval(1))/2;
if (n==1)
  % x = breakpoint;
  x = unifrnd(interval(1),interval(2));
elseif (n==0)
  x =[];
else
  t = linspace(interval(1), interval(2), 2000);
  nL = binornd(n,sum(willettpdf(t(1:1000)))/sum(willettpdf(t)));
  nR = n-nL;
  xL = willettrnd(nL,[interval(1) breakpoint]);
  xR = willettrnd(nR,[breakpoint interval(2)]);
  x = [xL; xR];
end

return